document.writeln("<H1>Arrays: sorting. Function (object) as a parameter </H1>");

var n=[12, 2, 3, 30, 1, 14];
document.writeln ("original array of numbers: " + n  + "<br>");

n.sort();
document.writeln ("sorted ? array of numbers: " + n  + "<br>"); //by default sorts strings
	
n.sort(compareNumbers);

document.writeln ("sorted array of numbers: " + n  + "<br><hr>"); 

var mixed_array = ["ab", 2, 11, "cc", "cb", 7];
document.writeln ("original mixed array : " + mixed_array  + "<br>");
mixed_array.sort(compareMixed);
document.writeln ("sorted mixed array : " + mixed_array  + "<br>");

function compareNumbers(a,b)
{
	return a - b;
}

function compareMixed (a,b)
{
	if (a === b) {
		return 0;
	}

	if (typeof a === typeof b) {
		return a < b ? -1 : 1;
	}
	return typeof a < typeof b ? -1 : 1;
}

console.log("anonymous function definition: defined where it is used");
n=[12, 2, 3, 30, 1, 14];
console.log ("original array of numbers: " + n  + "\n");

n.sort(function (a,b) {return a-b;} );
console.log("sorted array of numbers: " + n  + "\n"); 