document.writeln("<H1>Exceptions</H1>");

tryIt();

function addToItself (a) 
{
	if (typeof a !== 'number') 
		{
			throw {                              //throws custom object
			name: 'TypeError',
			message: 'addToItself needs a number'
			}
		}
	
	return a + a;
};

function tryIt ()
{
	try
	{
		addToItself ("seven");
	}
	catch (e)
	{
		document.writeln(e.name + ': ' + e.message);
	}
}
